#!/usr/bin/env python3

import argparse
import util


def main(args):
    if args.validar_cert:
        util.validar_cert(args)
        return

    if args.dir_trabajo:
        entrada = util.validar_dir(args.dir_trabajo, 'entrada')
        generados = util.validar_dir(args.dir_trabajo, 'generados')
        por_timbrar = util.validar_dir(args.dir_trabajo, 'por_timbrar')
        timbrados = util.validar_dir(args.dir_trabajo, 'timbrados')
    else:
        entrada = args.dir_entrada
        generados = args.dir_generados
        por_timbrar = args.dir_por_timbrar
        timbrados = args.dir_timbrados

    if args.generar:
        util.make(entrada, generados)

    if args.sellar:
        util.stamp(generados, por_timbrar)

    if args.timbrar:
        util.stamp_pac(por_timbrar, timbrados)

    return


def _process_command_line_arguments():
    parser = argparse.ArgumentParser(
        description='CFDI Test')

    help = 'Validar certificados'
    parser.add_argument('-vc', '--validar-cert', help=help,
        action='store_true', default=False, required=False)
    parser.add_argument('-dc', '--dir-cert', default='')
    help = "Nombre de los certificados, el predeterminado es 'cert'"
    parser.add_argument('-n', '--nombre', help=help, default='cert')

    parser.add_argument('-d', '--dir-trabajo', dest='dir_trabajo', default='')
    parser.add_argument('-de', '--dir-entrada', dest='dir_entrada', default='')
    parser.add_argument('-dg', '--dir-generados', dest='dir_generados', default='')
    parser.add_argument('-ds', '--dir-sellados', dest='dir_sellados', default='')
    parser.add_argument('-dt', '--dir-timbrados', dest='dir_timbrados', default='')

    parser.add_argument('-g', '--generar', dest='generar',
        action='store_true', default=False, required=False)
    parser.add_argument('-s', '--sellar', dest='sellar',
        action='store_true', default=False, required=False)
    parser.add_argument('-t', '--timbrar', dest='timbrar',
        action='store_true', default=False, required=False)
    return parser.parse_args()


if __name__ == '__main__':
    args = _process_command_line_arguments()
    main(args)
